"
 COPYRIGHT (c) 1997 by Claus Gittinger / eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"





Label subclass:#DSVLabelView
	instanceVariableNames:'selector argument'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-DataSet'
!

!DSVLabelView class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by Claus Gittinger / eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"




!

documentation
"
    shows the labels assigned to the column descriptions. Used by the
    DataSetView

    [Instance variables:]

        columnView      <DSVColumnView> column view which shows the columns

    [author:]
        Claus Atzkern

    [see also:]
        DSVColumnView
        DataSetColumnSpec
        DataSetColumn
        DataSetView
"



! !

!DSVLabelView class methodsFor:'instance creation'!

column:aColumn in:aDataSetView
    "create a new label in a dataSetView
    "
    |lbl|

    lbl := self in:aDataSetView.
    lbl column:aColumn.
  ^ lbl
! !

!DSVLabelView methodsFor:'accessing'!

backgroundColor:aColor
    "set the background color
    "
    aColor ~~ bgColor ifTrue:[
        bgColor := aColor on:device.
        super viewBackground:bgColor.
        shown ifTrue:[self invalidate]
    ]


! !

!DSVLabelView methodsFor:'event handling'!

buttonPress:button x:x y:y
    "button is pressed
    "
    (button == 1 and:[selector notNil]) ifTrue:[
        self level:-2
    ] ifFalse:[
        super buttonPress:button x:x y:y
    ]

!

buttonRelease:button x:x y:y
    "button is released; perform action
    "
    |application|

    selector notNil ifTrue:[
        self level:1.

        (x < 0 or:[x > width or:[y < 0 or:[y > height]]]) ifFalse:[
            (application := self application) notNil ifTrue:[
                argument notNil ifTrue:[
                    application perform:selector with:argument
                ] ifFalse:[
                    application perform:selector
                ]
            ]
        ]
    ].

! !

!DSVLabelView methodsFor:'initialize / release'!

column:aColumn
    |label|

    fixSize := true.
    label   := aColumn label.

    (selector := aColumn labelActionSelector) notNil ifTrue:[
        selector numArgs ~~ 0 ifTrue:[
            (argument := aColumn labelActionArgument) isNil ifTrue:[
                argument := label
            ]
        ]
    ].

    aColumn labelFont notNil ifTrue:[
         self font:(aColumn labelFont)
    ].
    aColumn labelBackgroundColor notNil ifTrue:[
         self backgroundColor:(aColumn labelBackgroundColor)
    ].
    aColumn labelForegroundColor notNil ifTrue:[
         self foregroundColor:(aColumn labelForegroundColor)
    ].
    self adjust:(aColumn labelAlignment).
    self label:label.
    self level:1
! !

!DSVLabelView class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg2/DSVLabelView.st,v 1.10 1998-01-02 18:00:14 tz Exp $'
! !
